import requests
import wikipedia
import uuid

class Card():
    def __init__(self, cardId=uuid.uuid4(), pageId=wikipedia.page(wikipedia.random()).pageid):
        self.cardId = cardId
        self.pageId = pageId

    def validate(self):
        try:
            wikipedia.page(pageid=self.pageId)
        except Exception as e:
            raise self.Invalid("Page ID does not match a Wikipedia page.")

    def __str__(self):
        return json.dumps({
            "cardId": str(self.cardId),
            "pageId": self.pageId
            })

    class Invalid(Exception):
        def __init__(self, message, status_code=406):
            super().__init__(message)
            self.status_code = status_code
