import json

class SellOrder():
    def __init__(self, cardId=None, items=[], price=0, fee=0):
        super().__init__(
            orderType = "sell",
            cardId = cardId,
            fee = fee
            )
        self.items = items
        self.price = price

    def add_transaction(self, transaction):
        if transaction.cardId in self.items:
            # TODO: update database
            self.items.pop(transaction.cardId)
            self.transactions.append(transaction)

    def __str__(self):
        return json.dumps({
            "orderId": str(self.orderId),
            "timestamp": str(self.timestamp),
            "userId": str(self.userId),
            "orderType": str(self.orderType),
            "cardId": self.cardId,
            "items": self.items,
            "price": self.price,
            "fee": self.fee,
            "transactions": [str(each) for each in self.transactions]
            })
